(add-to-list 'format-alist '(my-one
                             "My format."
                             nil ;; no automatic decode
                             my-one-decode
                             my-one-encode
                             t     ;; encode modifies the region
                             nil)) ;; write removes from buffer-file-formats

(defun my-one-decode (beg end)
  end)

(defun my-one-encode (beg end buffer)
  (message "my-one-encode in %S" (current-buffer))

  (save-excursion
    (save-restriction
      (narrow-to-region beg end)

      (insert "THIS IS FORMAT ONE\n")

      (point-max))))


(add-to-list 'format-alist '(my-two
                             "My format."
                             nil ;; no automatic decode
                             my-two-decode
                             my-two-encode
                             t     ;; encode modifies the region
                             nil)) ;; write removes from buffer-file-formats

(defun my-two-decode (beg end)
  (save-excursion
    (save-restriction
      (narrow-to-region beg end)

      (goto-char beg)
      (if (looking-at "THIS IS FORMAT TWO\n")
          (delete-region (match-beginning 0) (match-end 0)))

      (point-max))))

(defun my-two-encode (beg end buffer)
  (message "my-two-encode in %S" (current-buffer))

  (save-excursion
    (save-restriction
      (narrow-to-region beg end)

      (goto-char (point-min))
      (insert "THIS IS FORMAT TWO\n")

      (save-current-buffer
        (find-file "/tmp/y")
        (format-decode-buffer 'my-one)
        (erase-buffer)
        (insert "this is buffer yyy text\n")
        (save-buffer)
        (kill-buffer nil))

      (point-max))))


(progn
  (find-file "/tmp/x")
  (format-decode-buffer 'my-two)
  (erase-buffer)
  (insert "hello world\n")
  (save-buffer)
  (kill-buffer nil)
  (find-file "/tmp/x"))
